
// *** RMS Generator File ***  16/4/2006 *** 13:48:23


void main(void)
{
int Tiles = 7200;
int MapSize = 2.0*sqrt(cNumberNonGaiaPlayers * Tiles);
rmSetMapSize(MapSize,MapSize);
rmSetMapElevationParameters(cElevTurbulence, 0.1, 7.5, 0.1, 7.0);
rmTerrainInitialize("yukon\ground1_yuk", 6);

	rmSetMapType("yukon");
	rmSetMapType("snow");
rmSetMapType("water");
rmSetMapType("land");
   rmSetLightingSet("yukon");
rmSetStatusText("",0.10);
int TRADE = rmCreateTradeRouteDistanceConstraint("trade route", 10.0);
int TC = rmCreateTypeDistanceConstraint("TCNORM", "TownCenter", 25.0);
int SEE = rmCreateTerrainDistanceConstraint("WASSER", "Water", true, 10.0);
int LAND = rmCreateTerrainDistanceConstraint("LAND", "Land", true, 15.0);
int POSTEN = rmCreateTypeDistanceConstraint("POSTEN", "socketTradeRoute", 25.0);
int SILBERMINE = rmCreateTypeDistanceConstraint("SILBERMINE", "mine", 25.0);
int SCHATZ = rmCreateTypeDistanceConstraint("SCHATZ", "abstractNugget", 50.0);
int ALL = rmCreateTypeDistanceConstraint("ALLES", "all", 4.0);
int GOLDMINE = rmCreateTypeDistanceConstraint("GOLDMINE", "mineGold", 30.0);
int TCSHORT = rmCreateTypeDistanceConstraint("TCKURZ", "TownCenter", 8.0);
int TCMIDDLE = rmCreateTypeDistanceConstraint("TCMITTEL", "TownCenter", 12.0);
int TCLONG = rmCreateTypeDistanceConstraint("TCLANG", "TownCenter", 60.0);
rmSetStatusText("",0.15);
int subCiv00=-1;
int subCiv01=-1;
int subCiv02=-1;
int subCiv03=-1;
int subCiv04=-1;
subCiv00=rmGetCivID("inuit");
rmSetSubCiv(0, "inuit");
subCiv01=rmGetCivID("inuit");
rmSetSubCiv(1, "inuit");
subCiv02=rmGetCivID("inuit");
rmSetSubCiv(2, "inuit");
subCiv03=rmGetCivID("inuit");
rmSetSubCiv(3,"inuit");
subCiv04=rmGetCivID("inuit");
rmSetSubCiv(4, "inuit");
rmSetStatusText("",0.20);
rmPlacePlayersCircular(0.380, 0.380, rmDegreesToRadians(10.0));
for(i = 1; <= cNumberNonGaiaPlayers)
{
int id = rmCreateArea("Player"+i);
rmSetAreaWarnFailure(id, false);
rmSetAreaSize(id, rmAreaTilesToFraction(800), rmAreaTilesToFraction(800));
rmSetAreaTerrainType(id,"yukon\ground1_yuk");
rmSetAreaBaseHeight(id,1);
rmSetAreaCoherence(id,1);
rmSetAreaHeightBlend(id,1.5);
rmSetAreaLocPlayer(id,i);
rmSetPlayerArea(i,id);
rmAddAreaConstraint(id, TRADE);
rmAddAreaConstraint(id, TC);
rmAddAreaConstraint(id, SEE);
rmAddAreaConstraint(id, POSTEN);
rmBuildArea(id);
int TCID = rmCreateObjectDef("Starting Towncenter"+i);
rmAddObjectDefItem(TCID,"TownCenter",1,0);
rmAddObjectDefConstraint(TCID, TRADE);
rmPlaceObjectDefAtLoc(TCID,i,rmPlayerLocXFraction(i),rmPlayerLocZFraction(i),1);
}
int Explorereinheit = rmCreateStartingUnitsObjectDef(5.0);
rmSetObjectDefMinDistance(Explorereinheit, 2.0);
rmSetObjectDefMaxDistance(Explorereinheit, 3.0);
int SilberID = rmCreateObjectDef("Silber am DZ");
rmAddObjectDefItem(SilberID, "mine", 1, 4);
rmSetObjectDefMinDistance(SilberID, 30.0);
rmSetObjectDefMaxDistance(SilberID, 50.0);
rmAddObjectDefConstraint(SilberID, TCSHORT);
int BeerenID = rmCreateObjectDef("Beeren am DZ");
rmAddObjectDefItem(BeerenID, "berryBush",5, 4.0);
rmSetObjectDefMinDistance(BeerenID, 18);
rmSetObjectDefMaxDistance(BeerenID, 18);
rmAddObjectDefConstraint(BeerenID, TCSHORT);
int BaumID=rmCreateObjectDef("Baeume am DZ");
rmSetObjectDefMinDistance(BaumID,18);
rmSetObjectDefMaxDistance(BaumID,18);
rmAddObjectDefConstraint(BaumID, TCSHORT);
int Tiere1ID=rmCreateObjectDef("Tiere nahe am DZ");
rmAddObjectDefItem(Tiere1ID,"elk", 10, 10.0);
rmSetObjectDefMinDistance(Tiere1ID, 20);
rmSetObjectDefMaxDistance(Tiere1ID, 30);
rmAddObjectDefConstraint(Tiere1ID, TCSHORT);
rmSetObjectDefCreateHerd(Tiere1ID, true);
int ExtrasID=rmCreateObjectDef("bonus starting crates");
rmAddObjectDefItem(ExtrasID, "crateOfFood", 2, 4.0);
rmAddObjectDefItem(ExtrasID, "crateOfWood", 2, 4.0);
rmAddObjectDefItem(ExtrasID, "crateOfCoin", 2, 4.0);
rmSetObjectDefMinDistance(ExtrasID,12);
rmSetObjectDefMaxDistance(ExtrasID,12);
rmAddObjectDefConstraint(ExtrasID, TCSHORT);
rmSetStatusText("",0.40);
int Schatz=rmCreateObjectDef("Schaetze");
rmAddObjectDefItem(Schatz, "Nugget",5, 300.0);
rmSetObjectDefMinDistance(Schatz, 50);
rmSetObjectDefMaxDistance(Schatz, 250.0);
rmAddObjectDefConstraint(Schatz, TCLONG);
rmAddObjectDefConstraint(Schatz, SCHATZ);
rmAddObjectDefConstraint(Schatz, GOLDMINE);
rmAddObjectDefConstraint(Schatz, SILBERMINE);
rmAddObjectDefConstraint(Schatz, TRADE);
int ExtraSilber= rmCreateObjectDef("Silberminen");
rmAddObjectDefItem(ExtraSilber, "mine",1, 500.0);
rmSetObjectDefMinDistance(ExtraSilber, 50);
rmSetObjectDefMaxDistance(ExtraSilber, 500.0);
rmAddObjectDefConstraint(ExtraSilber, TC);
rmAddObjectDefConstraint(ExtraSilber, SCHATZ);
rmAddObjectDefConstraint(ExtraSilber, GOLDMINE);
rmAddObjectDefConstraint(ExtraSilber, SILBERMINE);
rmAddObjectDefConstraint(ExtraSilber, TRADE);
rmSetStatusText("",0.50);
for (PlayerID=1;<=cNumberNonGaiaPlayers)
{
vector TCLocation = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, PlayerID));
rmPlaceObjectDefAtLoc(Explorereinheit, PlayerID,rmPlayerLocXFraction(PlayerID),rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(BaumID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(BaumID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(BaumID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(BaumID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(BeerenID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(SilberID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(Tiere1ID, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(ExtrasID, PlayerID,rmPlayerLocXFraction(PlayerID),rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(Schatz, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
rmPlaceObjectDefAtLoc(ExtraSilber, 0, rmPlayerLocXFraction(PlayerID), rmPlayerLocZFraction(PlayerID));
}
int HPostenID=rmCreateObjectDef("Handelsposten");
rmAddObjectDefItem(HPostenID, "SocketTradeRoute", 1, 0.0);
rmAddObjectDefConstraint(HPostenID, TC);
rmSetObjectDefAllowOverlap(HPostenID, true);
rmSetObjectDefMinDistance(HPostenID, 0.0);
rmSetObjectDefMaxDistance(HPostenID, 8.0);
vector tradeRoutePoint = cOriginVector;
rmSetStatusText("",0.55);
float Zufall1 = rmRandFloat(100,200);
int tradeRoute = rmCreateTradeRoute();
if(Zufall1<150) tradeRoutePoint = rmFindClosestPoint(0.95, 0.95, 1.0);
if(Zufall1>150) tradeRoutePoint = rmFindClosestPoint(0.10, 0.85,1);
rmAddTradeRouteWaypoint(tradeRoute, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)));
float A = rmRandFloat(0.18,0.55);
float B = rmRandFloat(0.68,0.84);
float C = rmRandFloat(0.18,0.55);
float D = rmRandFloat(0.68,0.84);
rmAddRandomTradeRouteWaypoints(tradeRoute, A, B,10,10);
rmAddRandomTradeRouteWaypoints(tradeRoute, 0.5, 0.5,10,10); 
rmAddRandomTradeRouteWaypoints(tradeRoute, D, C,10,10);
float Zufall2 = rmRandFloat(100,200);
if(Zufall2<150) tradeRoutePoint = rmFindClosestPoint(0.1, 0.1, 1.0);
if(Zufall2>150) tradeRoutePoint = rmFindClosestPoint(0.85, 0.10,1);
rmAddRandomTradeRouteWaypoints(tradeRoute, rmXMetersToFraction(xsVectorGetX(tradeRoutePoint)), rmZMetersToFraction(xsVectorGetZ(tradeRoutePoint)),10,10);
rmBuildTradeRoute(tradeRoute, "dirt");
rmSetStatusText("",0.60);
rmSetObjectDefTradeRouteID(HPostenID, tradeRoute);
vector HPostenPosition = rmGetTradeRouteWayPoint(tradeRoute, 0.20);
rmPlaceObjectDefAtPoint(HPostenID, 0, HPostenPosition);
HPostenPosition = rmGetTradeRouteWayPoint(tradeRoute, 0.35);
rmPlaceObjectDefAtPoint(HPostenID, 0, HPostenPosition);
HPostenPosition = rmGetTradeRouteWayPoint(tradeRoute, 0.50);
rmPlaceObjectDefAtPoint(HPostenID, 0, HPostenPosition);
HPostenPosition = rmGetTradeRouteWayPoint(tradeRoute, 0.65);
rmPlaceObjectDefAtPoint(HPostenID, 0, HPostenPosition);
HPostenPosition = rmGetTradeRouteWayPoint(tradeRoute, 0.80);
rmPlaceObjectDefAtPoint(HPostenID, 0, HPostenPosition);
int SeaSize = cNumberNonGaiaPlayers*40;
for (I=0;<30)
{
int Sea=rmCreateArea("Sea"+I);
rmSetAreaSize(Sea, rmAreaTilesToFraction(SeaSize), rmAreaTilesToFraction(SeaSize));
rmSetAreaWaterType(Sea, "New England Lake");
rmSetAreaWarnFailure(Sea, false);
rmSetAreaBaseHeight(Sea, 0.2);
float X = rmRandFloat(0.18,0.84);
float Z = rmRandFloat(0.18,0.84);
rmSetAreaLocation(Sea, X, Z);
rmSetAreaCoherence(Sea, 0.45);
//rmAddAreaConstraint(Sea, Rand_1);
rmAddAreaConstraint(Sea, TRADE);
rmAddAreaConstraint(Sea, TC);
rmAddAreaConstraint(Sea, SEE);
rmBuildArea(Sea);
}
rmSetStatusText("",0.70);
int Anzahl=20*cNumberNonGaiaPlayers;
int failCount=0;
for (i=0; <Anzahl)
{
int forest=rmCreateArea("forest "+i);
rmSetAreaWarnFailure(forest, false);
 rmSetAreaSize(forest, rmAreaTilesToFraction(30), rmAreaTilesToFraction(30));
rmSetAreaForestType(forest, "yukon forest");
      rmSetAreaForestDensity(forest, 0.2);
      rmSetAreaForestClumpiness(forest, 0.0);
      rmSetAreaForestUnderbrush(forest, 0.0);
rmSetAreaCoherence(forest, 0.2);
rmAddAreaConstraint(forest, TRADE);
rmAddAreaConstraint(forest, TCMIDDLE);
rmAddAreaConstraint(forest, ALL);
if(rmBuildArea(forest)==false)
{
failCount++;
if(failCount==5)
break;
}
else
failCount=0;
}
rmSetStatusText("",0.80);
int VillageID1 = rmCreateGrouping("Inuit village1", "native inuit village");
rmSetGroupingMinDistance(VillageID1, 0.0);
rmSetGroupingMaxDistance(VillageID1,rmXFractionToMeters(0.5));
rmAddGroupingConstraint(VillageID1,TC);
rmAddGroupingConstraint(VillageID1,TRADE);
rmPlaceGroupingAtLoc(VillageID1, 0, 0.5, 0.5);
rmSetStatusText("",0.81);
int VillageID2 = rmCreateGrouping("Inuit village2", "native inuit village");
rmSetGroupingMinDistance(VillageID2, 0.0);
rmSetGroupingMaxDistance(VillageID2,rmXFractionToMeters(0.5));
rmAddGroupingConstraint(VillageID2,TC);
rmAddGroupingConstraint(VillageID2,TRADE);
rmPlaceGroupingAtLoc(VillageID2, 0, 0.5, 0.5);
rmSetStatusText("",0.82);
int VillageID3 = rmCreateGrouping("Inuit village3", "native inuit village");
rmSetGroupingMinDistance(VillageID3, 0.0);
rmSetGroupingMaxDistance(VillageID3,rmXFractionToMeters(0.5));
rmAddGroupingConstraint(VillageID3,TC);
rmAddGroupingConstraint(VillageID3,TRADE);
rmPlaceGroupingAtLoc(VillageID3, 0, 0.5, 0.5);
rmSetStatusText("",0.83);
int VillageID4 = rmCreateGrouping("Inuit village4", "native inuit village");
rmSetGroupingMinDistance(VillageID4, 0.0);
rmSetGroupingMaxDistance(VillageID4,rmXFractionToMeters(0.5));
rmAddGroupingConstraint(VillageID4,TC);
rmAddGroupingConstraint(VillageID4,TRADE);
rmPlaceGroupingAtLoc(VillageID4, 0, 0.5, 0.5);
rmSetStatusText("",0.84);
int VillageID5 = rmCreateGrouping("Inuit village5", "native inuit village");
rmSetGroupingMinDistance(VillageID5, 0.0);
rmSetGroupingMaxDistance(VillageID5,rmXFractionToMeters(0.5));
rmAddGroupingConstraint(VillageID5,TC);
rmAddGroupingConstraint(VillageID5,TRADE);
rmPlaceGroupingAtLoc(VillageID5, 0, 0.5, 0.5);
rmSetStatusText("",0.85);
rmSetStatusText("",0.95);
//*******************************************************************Ende
}
